﻿using System;
using System.Text.RegularExpressions;
using System.Collections.Generic;
using System.Windows.Forms;
using WindowsLive.Writer.Api;

namespace CollapseExpandPlugin
{
    [WriterPlugin("{0a6f608b-7d80-492d-a42c-8027dcd9b51a}",
       "Collapse & Expand",
       PublisherUrl = "http://www.cnblogs.com/huyh",
       Description = "Add Collapse & Expand function.",
       ImagePath = "icon-collapse.gif",
       HasEditableOptions = false)]
    [InsertableContentSource("Collapse & Expand")]
    public class CollapseExpandPlugin : ContentSource
    {
        public override DialogResult CreateContent(IWin32Window dialogOwner, ref string content)
        {
            try
            {
                string random = DateTime.Now.Ticks.ToString();
                string expand = String.Format("<pre id=\"collapse_{0}\" class=\"code\"><a href=\"javascript:void(0);\" onclick=\"document.getElementById('expand_{0}').style.display='block';document.getElementById('collapse_{0}').style.display='none';\">展开</a></pre>", random);
                string collapse = String.Format("<pre style=\"display: none\" id=\"expand_{0}\" class=\"code\"><a href=\"javascript:void(0);\" onclick=\"document.getElementById('collapse_{0}').style.display='block';document.getElementById('expand_{0}').style.display='none';\">折叠</a>\r\n\r\n", random);
                content = Regex.Replace(content, @"<pre\s+[^>]*>", expand + collapse,RegexOptions.IgnoreCase|RegexOptions.Multiline);
                return DialogResult.OK;
            }
            catch
            {
                MessageBox.Show("Collapse & Expand could not convert that content.", "Convert Problem", MessageBoxButtons.OK, MessageBoxIcon.Hand);
            }
            return DialogResult.Cancel;
        }     
    }
}
