﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WindowsLive.Writer.Api;

namespace CopyrightPlugin
{
    [WriterPlugin("{af97f0a3-9683-47f3-b4a0-cc68a0b252b7}", 
        "Paste CopyRight", 
        PublisherUrl = "http://www.cnblogs.com/huyh", 
        Description = "Paste copyright information to the blog.",
        ImagePath = "copyright.png", 
        HasEditableOptions = true)]
    [InsertableContentSource("Paste CopyRight")]
    public class CopyrightPlugin : ContentSource
    {
        private Option _option = new Option();
        public override DialogResult CreateContent(IWin32Window dialogOwner, ref string content)
        {
            content = _option.Value;
            return DialogResult.OK;
        }
        public override void EditOptions(IWin32Window dialogOwner)
        {
            OptionForm form = new OptionForm(this._option);
            if (form.ShowDialog() == DialogResult.OK)
            {
                this._option = form.Option;
                Utility.WriteOptionsToStorage(Options, this._option);
            }
        }
        public override void Initialize(IProperties pluginOptions)
        {
            base.Initialize(pluginOptions);
            this._option = Utility.ReadOptionsFromStorage(pluginOptions);
        }
    }
}
